VERSION 5.00
Begin VB.UserControl ulistctrl 
   ClientHeight    =   450
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1470
   ScaleHeight     =   450
   ScaleWidth      =   1470
   Begin VB.ListBox ulist 
      Height          =   450
      ItemData        =   "UList.ctx":0000
      Left            =   0
      List            =   "UList.ctx":0002
      TabIndex        =   0
      Top             =   0
      Width           =   1455
   End
End
Attribute VB_Name = "ulistctrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' This code uses an ordinary listbox and adds the feature
' that when you use additem to add an item, it checks
' if the value is already there. If it is, the new value
' is not added.
' sort of a control version of the stringset
' we provide some but not all the properties and methods
' of the listbox

Public Event clicked() ' let the user know something selected

' if the user resizes the control, we
' want the listbox to change size to match
Private Sub UserControl_Resize()
    ulist.Height = UserControl.ScaleHeight
    ulist.Width = UserControl.ScaleWidth
End Sub

' events on the interior control must be raised to the
' exterior
Private Sub ulist_Click()
    RaiseEvent clicked
End Sub

' wrap the ListBox AddItem method so it can be used
' by the ulist user. It also makes sure that the
' added string is not already in the list
Public Sub additem(str As String)
    Dim x As Integer
    If str = "" Then Exit Sub
    For x = 0 To ulist.ListCount - 1
        If ulist.List(x) = str Then Exit Sub
    Next
    ulist.additem str
End Sub

' retrieve the selected value and pass it to the user
Public Property Get selected() As String
    selected = ulist.Text
End Property

' get the list count for the user
Public Property Get count() As String
    count = ulist.ListCount
End Property
